<template>
  <div>
    <div>
      <div class="top-nav">
        <router-link class="active" to="/dashboard">Home</router-link>
        <div class="top-nav-right">
          <router-link to="/account">Account</router-link>
          <router-link to="/logout">Logout</router-link>
        </div>
      </div>
    </div>
    <div class="card">
      <h5 style="font-weight: bold"> {{ nameComponent.toUpperCase() }} COMPONENT </h5>
      <b-card-group deck>
        <b-card class="card-body">
          <b-card-header header-text-variant="white" header-bg-variant="dark">
            BASIC HEALTHCHECKS
          </b-card-header>
          <br>
          <li v-for="item in items" :key="item">
            <b-row class="my-1">
              <b-col sm="10">
                <strong>ID:</strong> {{ item.id }} <br>
                <strong>Component:</strong> {{ item.component }} <br>
                <strong>Healthcheck name:</strong> {{ item.name }} <br>
                <strong>URL:</strong> {{ item.url }} <br>
                <strong>Method:</strong> {{ item.method }} <br>
                <strong>Status:</strong> {{ item.status }} <br>
                <strong>Incident name:</strong> {{ item.incident }} <br>
                <strong>Backoff:</strong> {{ item.retry }} <br>
                <b-button variant="warning" v-b-modal="'basicModal'" user="'item'"
                          @click="sendInfo(item)">Edit</b-button>
                <b-button variant="danger" v-on:click="deleteBasic(item.id)">Delete</b-button>
              </b-col>
            </b-row>
          </li>
        </b-card>
        <b-card class="card-body">
          <b-card-header header-text-variant="white" header-bg-variant="dark">
            COMPLEX HEALTHCHECKS
          </b-card-header>
          <br>
          <li v-for="item in itemsComplex" :key="item">
            <b-row class="my-1">
              <b-col sm="10">
                <strong>ID:</strong> {{ item.id }} <br>
                <strong>Component:</strong> {{ item.component }} <br>
                <strong>Healthcheck name:</strong> {{ item.name }} <br>
                <strong>Code:</strong> {{ item.code }} <br>
                <strong>Incident name:</strong> {{ item.incident }} <br>
                <strong>Backoff:</strong> {{ item.retry }} <br>
                <b-button variant="warning" v-b-modal="'complexModal'" user="'item'"
                          @click="sendInfoComplex(item)">Edit</b-button>
                <b-button variant="danger" v-on:click="deleteComplex(item.id)">Delete</b-button>
              </b-col>
            </b-row>
          </li>
        </b-card>
      </b-card-group>
      <b-modal id="basicModal" size="lg" hide-footer hide-header ref="basic-modal">
        <div class="partition-form">
          <form>
            <label>Healthcheck ID</label>
            <input type="text" disabled id="id" v-model="selectedBasic.id">

            <label>Component ID</label>
            <input type="text" disabled id="component" v-model="selectedBasic.component">

            <label>Name</label>
            <input type="text" id="name" v-model="selectedBasic.name"
                   placeholder="Enter the name of the healthcheck..">

            <label>URL</label>
            <input type="text" id="url" v-model="selectedBasic.url" placeholder="Enter the url..">

            <label>Method</label>
            <select id="method" v-model="selectedBasic.method">
              <option value="GET">GET</option>
              <option value="POST">POST</option>
              <option value="PUT">PUT</option>
              <option value="DELETE">DELETE</option>
            </select>

            <label>Status</label>
            <input type="text" id="status" v-model="selectedBasic.status"
                   placeholder="Enter the status code..">

            <label>Incident</label>
            <input type="text" id="incident" v-model="selectedBasic.incident"
                   placeholder="Enter the name of the incident..">

            <label>Backoff</label>
            <select id="method" v-model="selectedBasic.retry">
              <option v-bind:value="true">TRUE</option>
              <option v-bind:value="false">FALSE</option>
            </select>

            <b-button class="mt-3" variant="warning" block @click="onUpdate">Update</b-button>
            <b-button class="mt-2" variant="danger" block @click="hideModal">Cancel</b-button>
          </form>
        </div>
      </b-modal>
      <b-modal id="complexModal" size="lg" hide-footer hide-header ref="complex-modal">
        <div class="modal-title">
          <form>
            <label>Healthcheck ID</label>
            <input type="text" disabled id="id-complex" v-model="selectedComplex.id">

            <label>Component ID</label>
            <input type="text" disabled id="component-complex" v-model="selectedComplex.component">

            <label>Name</label>
            <input type="text" id="name-complex" v-model="selectedComplex.name"
                   placeholder="Enter the name of the healthcheck..">

            <label>Code</label>
            <b-form-textarea id="code-complex"
                             placeholder="Enter the code of the complex healthcheck.."
                             rows="6" max-rows="9"
                             v-model="selectedComplex.code" required></b-form-textarea>

            <label>Incident</label>
            <input type="text" id="incident-complex" v-model="selectedComplex.incident"
                   placeholder="Enter the name of the incident..">

            <label>Backoff</label>
            <select id="method" v-model="selectedComplex.retry">
              <option v-bind:value="true">TRUE</option>
              <option v-bind:value="false">FALSE</option>
            </select>

            <b-button class="mt-3" variant="warning"
                      block @click="onUpdateComplex">Update</b-button>
            <b-button class="mt-2" variant="danger"
                      block @click="hideModal">Cancel</b-button>
          </form>
        </div>
      </b-modal>
    </div>
  </div>
</template>

<script>
import axios from 'axios';

export const SERVER_API_URL = process.env.SERVER_API_URL || '';

export default {
  name: 'ComponentInfo',
  data() {
    return {
      selectedBasic: {
        id: '',
        component: '',
        name: '',
        url: '',
        method: '',
        status: '',
        incident: '',
        retry: '',
      },
      selectedComplex: {
        id: '',
        component: '',
        name: '',
        code: '',
        incident: '',
        retry: '',
      },
      items: '',
      itemsComplex: '',
      nameComponent: '',
    };
  },
  methods: {
    sendInfo(item) {
      this.selectedBasic.id = item.id;
      this.selectedBasic.component = item.component;
      this.selectedBasic.name = item.name;
      this.selectedBasic.url = item.url;
      this.selectedBasic.method = item.method;
      this.selectedBasic.status = item.status;
      this.selectedBasic.incident = item.incident;
      this.selectedBasic.retry = item.retry;
    },
    sendInfoComplex(item) {
      this.selectedComplex.id = item.id;
      this.selectedComplex.component = item.component;
      this.selectedComplex.name = item.name;
      this.selectedComplex.code = item.code;
      this.selectedComplex.incident = item.incident;
      this.selectedComplex.retry = item.retry;
    },
    hideModal() {
      this.$refs['basic-modal'].hide();
      this.$refs['complex-modal'].hide();
    },
    getNameComponentById(id) {
      const path = `${SERVER_API_URL}/v1.0/components/${id}`; // Component ID
      axios.get(path)
        .then((res) => {
          if (res.status === 200) {
            this.nameComponent = res.data;
            console.log(this.nameComponent);
          }
        })
        .catch((error) => {
          console.error(error);
        });
    },
    getBasicsByComponent(id) {
      const path = `${SERVER_API_URL}/v1.0/basic/${id}`; // Component ID
      axios.get(path)
        .then((res) => {
          if (res.status === 200) {
            this.items = res.data;
          }
        })
        .catch((error) => {
          console.error(error);
        });
    },
    getComplexByComponent(id) {
      const path = `${SERVER_API_URL}/v1.0/complex/${id}`; // Component ID
      axios.get(path)
        .then((res) => {
          if (res.status === 200) {
            this.itemsComplex = res.data;
          }
        })
        .catch((error) => {
          console.error(error);
        });
    },
    onUpdate(evt) {
      evt.preventDefault();
      const payload = {
        id: this.selectedBasic.id,
        component: this.selectedBasic.component,
        name: this.selectedBasic.name,
        url: this.selectedBasic.url,
        method: this.selectedBasic.method,
        status: this.selectedBasic.status,
        incident: this.selectedBasic.incident,
        retry: this.selectedBasic.retry,
      };
      this.updateBasic(payload);
    },
    updateBasic(payload) {
      const path = `${SERVER_API_URL}/v1.0/basic/update`;
      axios.defaults.headers['Content-Type'] = 'application/json';
      const json = JSON.stringify(payload);
      axios.put(path, json)
        .then((res) => {
          if (res.status === 204) {
            this.$router.go(this.$router.currentRoute);
          }
        })
        .catch((error) => {
          console.error(error);
        });
    },
    onUpdateComplex(evt) {
      evt.preventDefault();
      const payload = {
        id: this.selectedComplex.id,
        component: this.selectedComplex.component,
        name: this.selectedComplex.name,
        code: this.selectedComplex.code,
        incident: this.selectedComplex.incident,
        retry: this.selectedComplex.retry,
      };
      this.updateComplex(payload);
    },
    updateComplex(payload) {
      console.log(payload);
      const path = `${SERVER_API_URL}/v1.0/complex/update`;
      axios.defaults.headers['Content-Type'] = 'application/json';
      const json = JSON.stringify(payload);
      console.log(json);
      axios.put(path, json)
        .then((res) => {
          if (res.status === 204) {
            this.$router.go(this.$router.currentRoute);
          }
        })
        .catch((error) => {
          console.error(error);
        });
    },
    deleteBasic(id) {
      const path = `${SERVER_API_URL}/v1.0/basic/${id}`;
      axios.delete(path)
        .then((res) => {
          if (res.status === 204) {
            this.$router.go(this.$router.currentRoute);
          }
        })
        .catch((error) => {
          console.error(error);
        });
    },
    deleteComplex(id) {
      const path = `${SERVER_API_URL}/v1.0/complex/${id}`;
      axios.delete(path)
        .then((res) => {
          if (res.status === 204) {
            this.$router.go(this.$router.currentRoute);
          }
        })
        .catch((error) => {
          console.error(error);
        });
    },
  },
  created() {
    this.getNameComponentById(this.$route.query.id);
    this.getBasicsByComponent(this.$route.query.id);
    this.getComplexByComponent(this.$route.query.id);
  },
};

</script>

<style scoped>

h4 {
  margin-top: 10px;
}

.btn {
  float: left;
  margin-top: 1rem;
  margin-bottom: 1rem;
  margin-right: 1rem;
  text-transform: unset;
}

.mt-3 {
  margin-top: 0rem;
  margin-bottom: 0;
  margin-right: 1rem;
  text-transform: unset;
}

input[type=text], select {
  width: 100%;
  padding: 12px 20px;
  margin: 1px 0;
  display: inline-block;
  border: 1px solid #ccc;
  border-radius: 8px;
  box-sizing: border-box;
}

div.partition-form {
  height: 880px;
  border-radius: 10px;
  background-color: #f2f2f2;
  padding: 20px;
}

div.modal-title {
  height: 800px;
  border-radius: 10px;
  background-color: #f2f2f2;
  padding: 20px;
}

.card {
  text-align: left;
  margin: 50px 20px 20px;
  padding: 20px 40px;
  width: auto;
  height: auto;
  box-shadow: 0 8px 26px -4px rgba(0,0,0,0.15);
  border-radius: 5px;
  background: var(--grey-light);
}

.card-body {
  text-align: left;
  margin: 20px 20px 0px;
  padding: 0 0;
  width: auto;
  height: auto;
  background: var(--white);
}

</style>
